## pwncat 0.1.2

=== Makefile ===
ifneq (,)
.error This Makefile requires GNU Make.
endif

# -------------------------------------------------------------------------------------------------
# Can be changed
# -------------------------------------------------------------------------------------------------
# This can be adjusted
PYTHON_VERSION = 2.7


# -------------------------------------------------------------------------------------------------
# Default configuration
# -------------------------------------------------------------------------------------------------
.PHONY: help lint code test smoke autoformat docs pipeline build deploy clean

BINPATH = bin/
MANPATH = man/
DOCPATH = docs/
INTPATH = tests/integration/
BINNAME = pwncat

FL_VERSION = 0.4
FL_IGNORES = .git/,.github/,$(BINNAME).egg-info,docs/$(BINNAME).api.html,docs/,data/,.mypy_cache/,share/doc/venv,share/doc/_build,share/pkg/nixos,share/pkg/blackarch/

UID := $(shell id -u)
GID := $(shell id -g)


# -------------------------------------------------------------------------------------------------
# Default Target
# -------------------------------------------------------------------------------------------------
help:
	@echo " ██▓███   █     █░ ███▄    █  ▄████▄   ▄▄▄      ▄▄▄█████▓"
	@echo "▓██░  ██▒▓█░ █ ░█░ ██ ▀█   █ ▒██▀ ▀█  ▒████▄    ▓  ██▒ ▓▒"
	@echo "▓██░ ██▓▒▒█░ █ ░█ ▓██  ▀█ ██▒▒▓█    ▄ ▒██  ▀█▄  ▒ ▓██░ ▒░"
	@echo "▒██▄█▓▒ ▒░█░ █ ░█ ▓██▒  ▐▌██▒▒▓▓▄ ▄██▒░██▄▄▄▄██ ░ ▓██▓ ░ "
	@echo "▒██▒ ░  ░░░██▒██▓ ▒██░   ▓██░▒ ▓███▀ ░ ▓█   ▓██▒  ▒██▒ ░ "
	@echo "▒▓▒░ ░  ░░ ▓░▒ ▒  ░ ▒░   ▒ ▒ ░ ░▒ ▒  ░ ▒▒   ▓▒█░  ▒ ░░   "
	@echo "░▒ ░       ▒ ░ ░  ░ ░░   ░ ▒░  ░  ▒     ▒   ▒▒ ░    ░    "
	@echo "░░         ░   ░     ░   ░ ░ ░          ░   ▒     ░      "
	@echo "             ░             ░ ░ ░            ░  ░         "
	@echo "                             ░                           "
	@echo
	@echo "lint             Lint repository"
	@echo "code             Lint source code"
	@echo "test             Run integration tests"
	@echo "smoke            Run smokke tests (dockerized)"
	@echo "autoformat       Autoformat code according to Python black"
	@echo
	@echo "docs             Update code documentation"
	@echo "pipeline         Update GitHub action workflow pipelines"
	@echo
	@echo "build            Build Python pkg, source and binary dist"
	@echo "deploy           Deploy pip package"
	@echo "clean            Clean the Build"


# -------------------------------------------------------------------------------------------------
# Lint Targets
# -------------------------------------------------------------------------------------------------
lint: _lint-files
lint: _lint-version
lint: _lint-usage
lint: _lint-docs
lint: _lint-man
lint: _lint-pipeline

.PHONY: _lint-version
_lint-version:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Check version config"
	@echo "# -------------------------------------------------------------------- #"
	@VERSION_PWNCAT=$$( grep -E '^VERSION = "[.0-9]+(-\w+)?"' bin/pwncat | awk -F'"' '{print $$2}' || true ); \
	VERSION_SETUP=$$( grep version= setup.py | awk -F'"' '{print $$2}' || true ); \
	VERSION_CHANGE=$$( grep -E '## Release [.0-9]+(-\w+)?$$' CHANGELOG.md | head -1 | sed 's/.*[[:space:]]//g' || true ); \
	if [ "$${VERSION_PWNCAT}" != "$${VERSION_SETUP}" ] || [ "$${VERSION_SETUP}" != "$${VERSION_CHANGE}" ]; then \
		echo "[ERROR] Version mismatch"; \
		echo "bin/pwncat:   $${VERSION_PWNCAT}"; \
		echo "setup.py:     $${VERSION_SETUP}"; \
		echo "CHANGELOG.md: $${VERSION_CHANGE}    # Looking for latest entry with regex format: '## Release [.0-9]+(\w+)?$$'" ; \
		exit 1; \
	else \
		echo "[OK] Version match"; \
		echo "bin/pwncat:   $${VERSION_PWNCAT}"; \
		echo "setup.py:     $${VERSION_SETUP}"; \
		echo "CHANGELOG.md: $${VERSION_CHANGE}"; \
		exit 0; \
	fi \

.PHONY: _lint-usage
_lint-usage: SHELL := /bin/bash
_lint-usage:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint usage"
	@echo "# -------------------------------------------------------------------- #"
	$(PWD)/tests/bin/check-usage.sh

.PHONY: _lint-files
_lint-files:
	@echo "# --------------------------------------------------------------------"
	@echo "# Lint files"
	@echo "# -------------------------------------------------------------------- #"
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-cr --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-crlf --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-trailing-single-newline --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-trailing-space --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-utf8 --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) file-utf8-bom --text --ignore '$(FL_IGNORES)' --path .
	@docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data cytopia/file-lint:$(FL_VERSION) git-conflicts --text --ignore '$(FL_IGNORES)' --path .

.PHONY: _lint-docs
_lint-docs:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint docs"
	@echo "# -------------------------------------------------------------------- #"
	@$(MAKE) --no-print-directory docs
	git diff --quiet -- $(DOCPATH) || { echo "Build Changes"; git diff | cat; git status; false; }
	git diff --quiet -- $(PWD)/README.md || { echo "Build Changes"; git diff | cat; git status; false; }

.PHONY: _lint-man
_lint-man:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint man page"
	@echo "# -------------------------------------------------------------------- #"
	@$(MAKE) --no-print-directory man
	git diff --quiet -- $(DOCPATH) $(MANPATH) || { echo "Build Changes"; git diff | cat; git status; false; }

.PHONY: _lint-pipeline
_lint-pipeline:
	@echo "# -------------------------------------------------------------------- #"
	@echo "# Lint Pipelines"
	@echo "# -------------------------------------------------------------------- #"
	@$(MAKE) --no-print-directory pipeline
	git diff --quiet -- .github/workflows || { echo "Build Changes"; git diff | cat; git status; false; }


# -------------------------------------------------------------------------------------------------
# Code Style Targets
# -------------------------------------------------------------------------------------------------
code: _code-pycodestyle
code: _code-pydocstyle
code: _code-pylint
code: _code-black
code: _code-mypy

.PHONY: _code-pycodestyle
_code-pycodestyle:
	@V="$$( docker run --rm cytopia/pycodestyle --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check pycodestyle: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/pycodestyle
	docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data --entrypoint= cytopia/pycodestyle sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& pycodestyle --config=setup.cfg /tmp/$(BINNAME).py'

.PHONY: _code-pydocstyle
_code-pydocstyle:
	@V="$$( docker run --rm cytopia/pydocstyle --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check pydocstyle: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/pydocstyle
	docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data --entrypoint= cytopia/pydocstyle sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& pydocstyle --explain --config=setup.cfg /tmp/$(BINNAME).py'

.PHONY: _code-pylint
_code-pylint:
	@V="$$( docker run --rm cytopia/pylint --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check pylint: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/pylint
	docker run --rm $$(tty -s && echo "-it" || echo) -v $(PWD):/data --entrypoint= cytopia/pylint sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& pylint --rcfile=setup.cfg /tmp/$(BINNAME).py'

.PHONY: _code-black
_code-black:
	@V="$$( docker run --rm cytopia/black --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check Python Black: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/black
	docker run --rm $$(tty -s && echo "-it" || echo) -v ${PWD}:/data --entrypoint= cytopia/black sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& black -l 100 --check --diff /tmp/$(BINNAME).py'

.PHONY: _code-mypy
_code-mypy:
	@V="$$( docker run --rm cytopia/mypy --version | head -1 )"; \
	echo "# -------------------------------------------------------------------- #"; \
	echo "# Check Mypy: $${V}"; \
	echo "# -------------------------------------------------------------------- #"
	@#
	docker pull cytopia/mypy
	docker run --rm $$(tty -s && echo "-it" || echo) -v ${PWD}:/data --entrypoint= cytopia/mypy sh -c ' \
		mkdir -p /tmp \
		&& cp $(BINPATH)$(BINNAME) /tmp/$(BINNAME).py \
		&& mypy --config-file setup.cfg /tmp/$(BINNAME).py'


# -------------------------------------------------------------------------------------------------
# Smoke Targets
# -------------------------------------------------------------------------------------------------
smoke: _smoke-keep_open-kill_srv-before_send
smoke: _smoke-keep_open-kill_srv-send_data
smoke: _smoke-tcp_port_scan-no_banner
smoke: _smoke-tcp_port_scan-with_banner
smoke: _smoke-udp_port_scan-no_banner
smoke: _smoke-udp_port_scan-with_banner

.PHONY:
_smoke-keep_open-kill_srv-before_send:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "200---tcp---keep_open---kill_server---no_send" "$(PYTHON_VERSION)"

_smoke-keep_open-kill_srv-send_data:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "201---tcp---keep_open---kill_server---send_data" "$(PYTHON_VERSION)"

_smoke-tcp_port_scan-no_banner:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"
	tests/smoke/run.sh "300---tcp---port_scan---no_banner" "$(PYTHON_VERSION)"

_smoke-tcp_port_scan-with_banner:
	@# It's sometimes a race-condition, so we run it five times
	tests/smoke/run.sh "301---tcp---port_scan---with_banner" "$(PYTHON_VERSION)"

=== share/doc/Makefile ===
ifneq (,)
.error This Makefile requires GNU Make.
endif

# -------------------------------------------------------------------------------------------------
# Default configuration
# -------------------------------------------------------------------------------------------------
.PHONY: help build autobuild linkcheck linkcheck2


# -------------------------------------------------------------------------------------------------
# Default Target
# -------------------------------------------------------------------------------------------------

help:
	@echo "build            Build and test documentation"
	@echo "autobuild        Continuously run and build (http://0.0.0.0:8000)"
	@echo "linkcheck        Sphinx linkcheck"
	@echo "linkcheck2       Custom linkcheck"


# -------------------------------------------------------------------------------------------------
#  Target
# -------------------------------------------------------------------------------------------------

linkcheck2:
	docker run \
		--rm \
		$$(tty -s && echo "-it" || echo) \
		-v $(PWD):/data \
		cytopia/linkcheck -l -k -r 60 -t 30 -e rst -c '200,204' _includes/

linkcheck:
	docker run \
		--rm \
		$$(tty -s && echo "-it" || echo) \
		-e SPHINX_PROJECT="doc" \
		-e SPHINX_PORT=8000 \
		-e NEW_UID="$$(id -u)" \
		-e NEW_GID="$$(id -g)" \
		-v $(PWD)/..:/shared/httpd \
		devilbox/python-sphinx:3.8-dev \
		sphinx-build -M linkcheck . _build

build:
	docker run \
		--rm \
		$$(tty -s && echo "-it" || echo) \
		-e SPHINX_PROJECT="doc" \
		-e SPHINX_PORT=8000 \
		-e NEW_UID="$$(id -u)" \
		-e NEW_GID="$$(id -g)" \
		-v $(PWD)/..:/shared/httpd \
		devilbox/python-sphinx:3.8-dev \
		sphinx-build -a -E -n -j auto -W . _build/html

autobuild:
	docker run \
		--rm \
		$$(tty -s && echo "-it" || echo) \
		-e SPHINX_PROJECT="doc" \
		-e SPHINX_PORT=8000 \
		-e NEW_UID="$$(id -u)" \
		-e NEW_GID="$$(id -g)" \
		-p "8000:8000" \
		-v $(PWD)/..:/shared/httpd \
		devilbox/python-sphinx:3.8-dev \
		sphinx-autobuild -a -E -n -j auto -W --host 0.0.0.0 --port 8000 . _build/html

=== share/doc/requirements.txt ===
recommonmark
sphinx_rtd_theme
Pygments

=== share/pkg/Makefile ===
SHELL = bash

# View versions here: https://repology.org/project/pwncat/versions


.PHONY: brew
brew:
	@mkdir -p $@
	.lib/brew.sh > $@/pwncat.rb
	@echo
	@echo "Update here"
	@echo "https://github.com/Homebrew/homebrew-core/blob/master/Formula/pwncat.rb"
	@echo


.PHONY: blackarch
blackarch:
	@mkdir -p $@
	.lib/blackarch.sh > $@/PKGBUILD
	@echo "pwncat" > $@/to-release
	@echo
	@echo "Update here"
	@echo "https://github.com/BlackArch/blackarch/blob/master/packages/pwncat/PKGBUILD"
	@echo "https://github.com/BlackArch/blackarch/blob/master/lists/to-release"
	@echo


.PHONY: nixos
nixos:
	@mkdir -p $@
	docker run -it --rm \
		-v $(PWD)/$@:/data \
		--entrypoint=sh \
		python:3-alpine -c " \
		pip install nixpkgs-pytools \
		&& python-package-init pwncat \
		&& cp default.nix /data/default.nix \
		&& chown $$(id -u):$$(id -g) /data/default.nix \
		"
	@echo
	@echo "Update here"
	@echo "https://github.com/NixOS/nixpkgs/blob/master/pkgs/tools/security/pwncat/default.nix"
	@echo


.PHONY: pentoo
pentoo:
	@mkdir -p $@
	docker run -it --rm \
		-v $(PWD)/.lib:/tmp \
		-v $(PWD)/pentoo:/data \
		--entrypoint=sh \
		python:2-alpine -c " \
		apk add \
			bash \
			curl \
			gcc \
			python2-dev \
			musl-dev \
		&& pip install pyblake2 \
		&& /tmp/pentoo.sh > /data/Manifest \
		&& chown $$(id -u):$$(id -g) /data/Manifest \
		"
	@echo
	@echo "Update here"
	@echo "https://github.com/pentoo/pentoo-overlay/blob/master/net-analyzer/pwncat/Manifest"
	@echo

=== debian/changelog ===
pwncat (0.1.2-0kali3) kali-dev; urgency=medium

  * Add a patch to fix output for autopkgtest in Python3.13
  * Refresh patches
  * Bump Standards-Version to 4.7.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 10 Feb 2025 17:08:40 +0100

pwncat (0.1.2-0kali2) kali-dev; urgency=medium

  * Add lintian override
  * Add patch for setuptools >= 61 compatibility.
  * Update standards version to 4.6.2, no changes needed.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Thu, 27 Apr 2023 21:09:24 -0500

pwncat (0.1.2-0kali1) kali-dev; urgency=medium

  [ Ben Wilson ]
  * Remove template comment and switch spaces to tabs

  [ Sophie Brun ]
  * New upstream version 0.1.2
  * Refresh patches
  * Bump Standards-Version to 4.6.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 11 Apr 2022 11:55:32 +0200

pwncat (0.1.1-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Sophie Brun ]
  * New upstream version 0.1.1
  * Refresh patches
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Bump Standards-Version to 4.5.1 (no change)
  * Use debhelper-compat 13
  * Remove failing test
  * Add another superficial autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 11 Jun 2021 15:53:58 +0200

pwncat (0.1.0-0kali1) kali-dev; urgency=medium

  * Initial release (see 6457)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 28 Jul 2020 11:04:58 +0200

=== debian/control ===
Source: pwncat
Section: utils
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-setuptools
Standards-Version: 4.7.0
Homepage: https://github.com/cytopia/pwncat
Vcs-Browser: https://gitlab.com/kalilinux/packages/pwncat
Vcs-Git: https://gitlab.com/kalilinux/packages/pwncat.git

Package: pwncat
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: netcat on steroids
 This package contains Netcat on steroids with Firewall, IDS/IPS evasion, bind
 and reverse shell, self-injecting shell and port forwarding magic - and its
 fully scriptable with Python (PSE).

=== debian/tests/control ===
Test-Command: tests/bin/check-usage.sh && pwncat -h
Restrictions: allow-stderr, superficial

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pwncat-$1.tar.gz%" \
   https://github.com/cytopia/pwncat/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
